#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>


/////////////////////////////////////////////////////////////////////////////
// Public functions

void AFXAPI DDX_Hex32Bit(CDataExchange* pDX, int nIDC, DWORD& dwValue)
{
	HWND hWnd = pDX->PrepareEditCtrl(nIDC);
	if (pDX->m_bSaveAndValidate)
	{
		TCHAR FieldText[12];
		::GetWindowText(hWnd, FieldText, 11);
		dwValue = strtoul(FieldText, NULL, 16);
	}
	else
	{
		CString str;
		str.Format(_T("%08.8x"), dwValue);
		::SetWindowText(hWnd, str.GetBufferSetLength(12));
	}
}


void AFXAPI DDX_Hex16Bit(CDataExchange* pDX, int nIDC, int& dwValue) //changed short to int, removed unsigned
{
	HWND hWnd = pDX->PrepareEditCtrl(nIDC);
	if (pDX->m_bSaveAndValidate)
	{
		TCHAR FieldText[12];
		::GetWindowText(hWnd, FieldText, 11);
		dwValue = (unsigned short)strtoul(FieldText, NULL, 16);
	}
	else
	{
		CString str;
		str.Format(_T("%04.4x"), dwValue);
		::SetWindowText(hWnd, str.GetBufferSetLength(8));
	}
}

void AFXAPI DDX_Hex12Bit(CDataExchange* pDX, int nIDC, int& dwValue) 
{
	HWND hWnd = pDX->PrepareEditCtrl(nIDC);
	if (pDX->m_bSaveAndValidate)
	{
		TCHAR FieldText[12];
		::GetWindowText(hWnd, FieldText, 11);
		dwValue = (unsigned short)strtoul(FieldText, NULL, 16);
	}
	else
	{
		CString str;
		str.Format(_T("%03.3x"), dwValue);
		::SetWindowText(hWnd, str.GetBufferSetLength(8));
	}
}

void AFXAPI DDX_Hex8Bit(CDataExchange* pDX, int nIDC, BYTE& dwValue)
{
	HWND hWnd = pDX->PrepareEditCtrl(nIDC);
	if (pDX->m_bSaveAndValidate)
	{
		TCHAR FieldText[12];
		::GetWindowText(hWnd, FieldText, 11);
		dwValue = (unsigned char)strtoul(FieldText, NULL, 16);
	}
	else
	{
		CString str;
		str.Format(_T("%02.2x"), (unsigned char)dwValue);
		::SetWindowText(hWnd, str.GetBufferSetLength(6));
	}
}

void AFXAPI DDX_Hex4Bit(CDataExchange* pDX, int nIDC, char& dwValue)
{
	HWND hWnd = pDX->PrepareEditCtrl(nIDC);
	if (pDX->m_bSaveAndValidate)
	{
		TCHAR FieldText[12];
		::GetWindowText(hWnd, FieldText, 11);
		dwValue = (unsigned char)strtoul(FieldText, NULL, 16);
	}
	else
	{
		CString str;
		str.Format(_T("%01.1x"), (unsigned char)dwValue);
		::SetWindowText(hWnd, str.GetBufferSetLength(6));
	}
}



